## Visuals

Visuals — Low-level display hardware information

## Functions

void | gdk_query_depths ()
void | gdk_query_visual_types ()
GList * | gdk_list_visuals ()
gint | gdk_visual_get_best_depth ()
GdkVisualType | gdk_visual_get_best_type ()
GdkVisual * | gdk_visual_get_system ()
GdkVisual * | gdk_visual_get_best ()
GdkVisual * | gdk_visual_get_best_with_depth ()
GdkVisual * | gdk_visual_get_best_with_type ()
GdkVisual * | gdk_visual_get_best_with_both ()
#define | gdk_visual_ref()
#define | gdk_visual_unref()
GdkScreen * | gdk_visual_get_screen ()
gint | gdk_visual_get_bits_per_rgb ()
void | gdk_visual_get_blue_pixel_details ()
GdkByteOrder | gdk_visual_get_byte_order ()
gint | gdk_visual_get_colormap_size ()
gint | gdk_visual_get_depth ()
void | gdk_visual_get_green_pixel_details ()
void | gdk_visual_get_red_pixel_details ()
GdkVisualType | gdk_visual_get_visual_type ()

## Types and Values

| GdkVisual
enum | GdkVisualType
enum | GdkByteOrder

## Includes

    #include <gdk/gdk.h>

## Description

A GdkVisual describes a particular video hardware display format. It includes information about the number of bits used for each color, the way the bits are translated into an RGB value for display, and the way the bits are stored in memory. For example, a piece of display hardware might support 24-bit color, 16-bit color, or 8-bit color; meaning 24/16/8-bit pixel sizes. For a given pixel size, pixels can be in different formats; for example the "red" element of an RGB pixel may be in the top 8 bits of the pixel, or may be in the lower 4 bits.

Usually you can avoid thinking about visuals in GTK+. Visuals are useful to interpret the contents of a GdkImage, but you should avoid GdkImage precisely because its contents depend on the display hardware; use GdkPixbuf instead, for all but the most low-level purposes. Also, anytime you provide a GdkColormap, the visual is implied as part of the colormap (`gdk_colormap_get_visual()`), so you won't have to provide a visual in addition.

There are several standard visuals. The visual returned by `gdk_visual_get_system()` is the system's default visual. `gdk_rgb_get_visual()` return the visual most suited to displaying full-color image data. If you use the calls in GdkRGB, you should create your windows using this visual (and the colormap returned by `gdk_rgb_get_colormap()`).

A number of functions are provided for determining the "best" available visual. For the purposes of making this determination, higher bit depths are considered better, and for visuals of the same bit depth, `GDK_VISUAL_PSEUDO_COLOR` is preferred at 8bpp, otherwise, the visual types are ranked in the order of (highest to lowest) `GDK_VISUAL_DIRECT_COLOR`, `GDK_VISUAL_TRUE_COLOR`, `GDK_VISUAL_PSEUDO_COLOR`, `GDK_VISUAL_STATIC_COLOR`, `GDK_VISUAL_GRAYSCALE`, then `GDK_VISUAL_STATIC_GRAY`.

## Functions

### gdk_query_depths ()

    void
    gdk_query_depths (gint **depths,
                      gint *count);

This function returns the available bit depths for the default screen. It's equivalent to listing the visuals (`gdk_list_visuals()`) and then looking at the depth field in each visual, removing duplicates.

The array returned by this function should not be freed.

#### Parameters

depths | return location for available depths. | [out][array]
count | return location for number of available depths. | [out]

### gdk_query_visual_types ()

    void
    gdk_query_visual_types (GdkVisualType **visual_types,
                            gint *count);

This function returns the available visual types for the default screen. It's equivalent to listing the visuals (`gdk_list_visuals()`) and then looking at the type field in each visual, removing duplicates.

The array returned by this function should not be freed.

#### Parameters

visual_types | return location for the available visual types |
count | return location for the number of available visual types |

### gdk_list_visuals ()

    GList *
    gdk_list_visuals (void);

Lists the available visuals for the default screen. (See `gdk_screen_list_visuals()`) A visual describes a hardware image data format. For example, a visual might support 24-bit color, or 8-bit color, and might expect pixels to be in a certain format.

Call `g_list_free()` on the return value when you're finished with it.

#### Returns

a list of visuals; the list must be freed, but not its contents.

[transfer container][element-type GdkVisual]

### gdk_visual_get_best_depth ()

    gint
    gdk_visual_get_best_depth (void);

Get the best available depth for the default GDK screen. "Best" means "largest," i.e. 32 preferred over 24 preferred over 8 bits per pixel.

#### Returns

best available depth

### gdk_visual_get_best_type ()

    GdkVisualType
    gdk_visual_get_best_type (void);

Return the best available visual type for the default GDK screen.

#### Returns

best visual type

### gdk_visual_get_system ()

    GdkVisual *
    gdk_visual_get_system (void);

Get the system's default visual for the default GDK screen. This is the visual for the root window of the display. The return value should not be freed.

#### Returns

system visual.

[transfer none]

### gdk_visual_get_best ()

    GdkVisual *
    gdk_visual_get_best (void);

Get the visual with the most available colors for the default GDK screen. The return value should not be freed.

#### Returns

best visual.

[transfer none]

### gdk_visual_get_best_with_depth ()

    GdkVisual *
    gdk_visual_get_best_with_depth (gint depth);

Get the best visual with depth `depth` for the default GDK screen. Color visuals and visuals with mutable colormaps are preferred over grayscale or fixed-colormap visuals. The return value should not be freed. `NULL` may be returned if no visual supports `depth` .

#### Parameters

depth | a bit depth |

#### Returns

best visual for the given depth.

[transfer none]

### gdk_visual_get_best_with_type ()

    GdkVisual *
    gdk_visual_get_best_with_type (GdkVisualType visual_type);

Get the best visual of the given `visual_type` for the default GDK screen. Visuals with higher color depths are considered better. The return value should not be freed. `NULL` may be returned if no visual has type `visual_type` .

#### Parameters

visual_type | a visual type |

#### Returns

best visual of the given type.

[transfer none]

### gdk_visual_get_best_with_both ()

    GdkVisual *
    gdk_visual_get_best_with_both (gint depth,
                                   GdkVisualType visual_type);

Combines `gdk_visual_get_best_with_depth()` and `gdk_visual_get_best_with_type()`.

#### Parameters

depth | a bit depth |
visual_type | a visual type |

#### Returns

best visual with both `depth` and `visual_type` , or `NULL` if none.

[transfer none]

### gdk_visual_ref()

    #define gdk_visual_ref(v) g_object_ref(v)

`gdk_visual_ref` is deprecated and should not be used in newly-written code.

Deprecated equivalent of `g_object_ref()`.

#### Parameters

v | a GdkVisual |

#### Returns

the same visual

### gdk_visual_unref()

    #define gdk_visual_unref(v) g_object_unref(v)

`gdk_visual_unref` is deprecated and should not be used in newly-written code.

Deprecated equivalent of `g_object_unref()`.

#### Parameters

v | a GdkVisual |

### gdk_visual_get_screen ()

    GdkScreen *
    gdk_visual_get_screen (GdkVisual *visual);

Gets the screen to which this visual belongs

#### Parameters

visual | a GdkVisual |

#### Returns

the screen to which this visual belongs.

[transfer none]

Since 2.2

### gdk_visual_get_bits_per_rgb ()

    gint
    gdk_visual_get_bits_per_rgb (GdkVisual *visual);

Returns the number of significant bits per red, green and blue value.

#### Parameters

visual | a GdkVisual |

#### Returns

The number of significant bits per color value for `visual` .

Since 2.22

### gdk_visual_get_blue_pixel_details ()

    void
    gdk_visual_get_blue_pixel_details (GdkVisual *visual,
                                       guint32 *mask,
                                       gint *shift,
                                       gint *precision);

Obtains values that are needed to calculate blue pixel values in TrueColor and DirectColor. The "mask" is the significant bits within the pixel. The "shift" is the number of bits left we must shift a primary for it to be in position (according to the "mask"). Finally, "precision" refers to how much precision the pixel value contains for a particular primary.

#### Parameters

visual | a GdkVisual |
mask | A pointer to a guint32 to be filled in, or `NULL`. | [out][allow-none]
shift | A pointer to a gint to be filled in, or `NULL`. | [out][allow-none]
precision | A pointer to a gint to be filled in, or `NULL`. | [out][allow-none]

Since 2.22

### gdk_visual_get_byte_order ()

    GdkByteOrder
    gdk_visual_get_byte_order (GdkVisual *visual);

Returns the byte order of this visual.

#### Parameters

visual | A GdkVisual. |

#### Returns

A GdkByteOrder stating the byte order of `visual` .

Since 2.22

### gdk_visual_get_colormap_size ()

    gint
    gdk_visual_get_colormap_size (GdkVisual *visual);

Returns the size of a colormap for this visual.

#### Parameters

visual | A GdkVisual. |

#### Returns

The size of a colormap that is suitable for `visual` .

Since 2.22

### gdk_visual_get_depth ()

    gint
    gdk_visual_get_depth (GdkVisual *visual);

Returns the bit depth of this visual.

#### Parameters

visual | A GdkVisual. |

#### Returns

The bit depth of this visual.

Since 2.22

### gdk_visual_get_green_pixel_details ()

    void
    gdk_visual_get_green_pixel_details (GdkVisual *visual,
                                        guint32 *mask,
                                        gint *shift,
                                        gint *precision);

Obtains values that are needed to calculate green pixel values in TrueColor and DirectColor. The "mask" is the significant bits within the pixel. The "shift" is the number of bits left we must shift a primary for it to be in position (according to the "mask"). Finally, "precision" refers to how much precision the pixel value contains for a particular primary.

#### Parameters

visual | a GdkVisual |
mask | A pointer to a guint32 to be filled in, or `NULL`. | [out][allow-none]
shift | A pointer to a gint to be filled in, or `NULL`. | [out][allow-none]
precision | A pointer to a gint to be filled in, or `NULL`. | [out][allow-none]

Since 2.22

### gdk_visual_get_red_pixel_details ()

    void
    gdk_visual_get_red_pixel_details (GdkVisual *visual,
                                      guint32 *mask,
                                      gint *shift,
                                      gint *precision);

Obtains values that are needed to calculate red pixel values in TrueColor and DirectColor. The "mask" is the significant bits within the pixel. The "shift" is the number of bits left we must shift a primary for it to be in position (according to the "mask"). Finally, "precision" refers to how much precision the pixel value contains for a particular primary.

#### Parameters

visual | A GdkVisual. |
mask | A pointer to a guint32 to be filled in, or `NULL`. | [out][allow-none]
shift | A pointer to a gint to be filled in, or `NULL`. | [out][allow-none]
precision | A pointer to a gint to be filled in, or `NULL`. | [out][allow-none]

Since 2.22

### gdk_visual_get_visual_type ()

    GdkVisualType
    gdk_visual_get_visual_type (GdkVisual *visual);

Returns the type of visual this is (PseudoColor, TrueColor, etc).

#### Parameters

visual | A GdkVisual. |

#### Returns

A GdkVisualType stating the type of `visual` .

Since 2.22

## Types and Values

### GdkVisual

    typedef struct {
      GObject parent_instance;

      GdkVisualType GSEAL (type);
      gint GSEAL (depth);
      GdkByteOrder GSEAL (byte_order);
      gint GSEAL (colormap_size);
      gint GSEAL (bits_per_rgb);

      guint32 GSEAL (red_mask);
      gint GSEAL (red_shift);
      gint GSEAL (red_prec);

      guint32 GSEAL (green_mask);
      gint GSEAL (green_shift);
      gint GSEAL (green_prec);

      guint32 GSEAL (blue_mask);
      gint GSEAL (blue_shift);
      gint GSEAL (blue_prec);
    } GdkVisual;

The GdkVisual structure contains information about a particular visual.

Example 5. Constructing a pixel value from components

    1
    2
    3
    4
    5
    6
    7
    8

    guint
    pixel_from_rgb (GdkVisual *visual,
                    guchar r, guchar b, guchar g)
    {
      return ((r >> (16 - visual->red_prec))   << visual->red_shift) |
             ((g >> (16 - visual->green_prec)) << visual->green_shift) |
             ((r >> (16 - visual->blue_prec))  << visual->blue_shift);
    }

#### Members

GObject `parent_instance`; | inherited portion from GObject |

### enum GdkVisualType

A set of values that describe the manner in which the pixel values for a visual are converted into RGB values for display.

#### Members

GDK_VISUAL_STATIC_GRAY | Each pixel value indexes a grayscale value directly. |
GDK_VISUAL_GRAYSCALE | Each pixel is an index into a color map that maps pixel values into grayscale values. The color map can be changed by an application. |
GDK_VISUAL_STATIC_COLOR | Each pixel value is an index into a predefined, unmodifiable color map that maps pixel values into RGB values. |
GDK_VISUAL_PSEUDO_COLOR | Each pixel is an index into a color map that maps pixel values into rgb values. The color map can be changed by an application. |
GDK_VISUAL_TRUE_COLOR | Each pixel value directly contains red, green, and blue components. The `red_mask`, `green_mask`, and `blue_mask` fields of the GdkVisual structure describe how the components are assembled into a pixel value. |
GDK_VISUAL_DIRECT_COLOR | Each pixel value contains red, green, and blue components as for `GDK_VISUAL_TRUE_COLOR`, but the components are mapped via a color table into the final output table instead of being converted directly. |

### enum GdkByteOrder

A set of values describing the possible byte-orders for storing pixel values in memory.

#### Members

GDK_LSB_FIRST | The values are stored with the least-significant byte first. For instance, the 32-bit value 0xffeecc would be stored in memory as 0xcc, 0xee, 0xff, 0x00. |
GDK_MSB_FIRST | The values are stored with the most-significant byte first. For instance, the 32-bit value 0xffeecc would be stored in memory as 0x00, 0xcc, 0xee, 0xff. |

## See Also

GdkImage, GdkColormap, GdkRGB